# pyLevelSet

![Github License](https://img.shields.io/github/license/Yihao-Shi/pyLevelSet)          ![Github stars](https://img.shields.io/github/stars/Yihao-Shi/pyLevelSet)          ![Github forks](https://img.shields.io/github/forks/Yihao-Shi/pyLevelSet)         [![PRs Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen.svg?style=flat-square)](http://makeapullrequest.com) 


## Brief description
Generate 3D level set particles, including surface mesh and signed distance field (SDF) with pure Python API. 
Developed by [Multiscale Geomechanics Lab](https://person.zju.edu.cn/en/nguo), Zhejiang University.

## Overview

## Example

## Quick start
### Dependencies
Note that the dependencies will be automatically installed by setup.py when following the directions below.

|Package name|Version|Features|
|:----------:|:-----:|:------:|
|[numpy](https://pypi.org/project/numpy/)|lastest version|Pre-processing|
|[scipy](https://pypi.org/project/SciPy/)|lastest version|Find roots|
|[scikit-image](https://scikit-image.org/)|lastest version|Marching cube method|
|[open3d](https://pypi.org/project/pybind11/)|lastest version|Reconstruct surface mesh|
|[trimesh](https://pypi.org/project/trimesh/)|lastest version|Import stl/obj files|
|[rtree](https://pypi.org/project/Rtree/)|lastest version|Neighbor search|
|[matplotlib](https://matplotlib.org/)|lastest version|Visualization|

### Installation

### Visualization

## API

## License
This project is licensed under the GNU General Public License v3 - see the [LICENSE](https://www.gnu.org/licenses/) for details.

## Acknowledgements
The project is inspired by [sdf](https://github.com/fogleman/sdf). Besides, we deliver special thanks to the excellent documentation on signed distance functions: [3D](https://iquilezles.org/articles/distfunctions/) and [2D]().

### Contributors
<a href="https://github.com/Yihao-Shi/pyLevelSet/graphs/contributors">
  <img src="https://contrib.rocks/image?repo=Yihao-Shi/pyLevelSet" />
</a>

### Contact us
- If you spot any issue or need any help, please mail directly to <a href = "mailto:shiyh26@zju.edu.cn">shiyh26@zju.edu.cn</a>.

## Release Notes
V0.1 (April 15, 2024)

- First release pyLevelSet
